Index: replex/element.c
===================================================================
--- replex/element.c	(revision 18755)
+++ replex/element.c	(working copy)
@@ -2,8 +2,10 @@
  * element.c: MPEG ELEMENTARY STREAM functions for replex
  *        
  *
- * Copyright (C) 2003 Marcus Metzler <mocm@metzlerbros.de>
+ * Copyright (C) 2003 - 2006
+ *                    Marcus Metzler <mocm@metzlerbros.de>
  *                    Metzler Brothers Systementwicklung GbR
+ *           (C) 2006 Reel Multimedia
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
@@ -26,19 +28,27 @@
 
 #include <stdio.h>
 #include <string.h>
+#include <stdlib.h>
 
 #include "element.h"
 #include "mpg_common.h"
 #include "pes.h"
 
 unsigned int slots [4] = {12, 144, 0, 0};
-unsigned int bitrates[3][16] =
-{{0,32,64,96,128,160,192,224,256,288,320,352,384,416,448,0},
- {0,32,48,56,64,80,96,112,128,160,192,224,256,320,384,0},
- {0,32,40,48,56,64,80,96,112,128,160,192,224,256,320,0}};
+const uint16_t bitrates[2][3][15] = {
+    { {0, 32, 64, 96, 128, 160, 192, 224, 256, 288, 320, 352, 384, 416, 448 },
+      {0, 32, 48, 56, 64, 80, 96, 112, 128, 160, 192, 224, 256, 320, 384 },
+      {0, 32, 40, 48, 56, 64, 80, 96, 112, 128, 160, 192, 224, 256, 320 } },
+    { {0, 32, 48, 56, 64, 80, 96, 112, 128, 144, 160, 176, 192, 224, 256},
+      {0, 8, 16, 24, 32, 40, 48, 56, 64, 80, 96, 112, 128, 144, 160},
+      {0, 8, 16, 24, 32, 40, 48, 56, 64, 80, 96, 112, 128, 144, 160}
+    }
+};
 
-uint32_t freq[4] = {441, 480, 320, 0};
-static uint64_t samples[4] = { 384, 1152, 1152, 1536};
+const uint16_t freqs[3] = { 44100, 48000, 32000 };
+
+static uint32_t samples[4] = { 384, 1152, 1152, 1536};
+
 char *frames[3] = {"I-Frame","P-Frame","B-Frame"};
 
 unsigned int ac3_bitrates[32] =
@@ -58,16 +68,23 @@
 	return newpts>0 ? newpts%MAX_PTS2: MAX_PTS2+newpts;
 }
 
-void fix_audio_count(uint64_t *acount, audio_frame_t *aframe, uint64_t origpts, uint64_t pts)
+int  cfix_audio_count(audio_frame_t *aframe, uint64_t origpts, uint64_t pts)
 {
 	int64_t diff;
 	uint64_t di;
 	int c=0;
-
 	di = (samples [3-aframe->layer] * 27000000ULL);
 	diff = ptsdiff(origpts,pts);
 	c=(aframe->frequency * diff+di/2)/di;
-	if (c) fprintf(stderr,"fix audio frames %d\n",c);
+	return c;
+}
+
+
+void fix_audio_count(uint64_t *acount, audio_frame_t *aframe, uint64_t origpts, uint64_t pts)
+{
+	int c=0;
+
+	c = cfix_audio_count(aframe, origpts, pts);
 	*acount += c;
 }
 
@@ -79,8 +96,13 @@
 
 	
 	if ( s->pulldown == NOPULLDOWN ) {
-		newdts = ( (fcount-1) * SEC_PER + *pts);
-		newpts = ((fnum ) * SEC_PER + *pts);
+		if (s->progressive == TWO_FIELD){
+			newdts = ( (fcount-2) * SEC_PER*2 + *pts);
+			newpts = ((fnum-1 ) * SEC_PER*2 + *pts);
+		} else {
+			newdts = ( (fcount-1) * SEC_PER + *pts);
+			newpts = ((fnum ) * SEC_PER + *pts);
+		} 
 	} else {
 		uint64_t extra_time = 0;
 //		fprintf(stderr,"pulldown %d %d\n",(int) fcount-1, fnum-1);
@@ -144,10 +166,47 @@
 			  (int)fr/2);
 }
 
-	
+int FindPacketHeader(const uint8_t *Data, int s, int l);
+
+void inserttime(uint8_t *buf, uint8_t h, uint8_t m, uint8_t s)
+{
+	buf[4] &= ~(0x7F); 
+	buf[4] |= (h & 0x1F) << 2;
+	buf[4] |= (m & 0x30) >> 4;
+
+	buf[5] &= ~(0xF7);
+	buf[5] |= (m & 0x0F) << 4;
+	buf[5] |= (s & 0x38) >> 3;
+
+	buf[6] &= ~(0xE0);
+        buf[6] |= (s & 0x07) << 5;
+}
+
 void pts2time(uint64_t pts, uint8_t *buf, int len)
 {
 	uint8_t h,m,s;
+	int c=0,x;
+//	uint8_t *data=buf;
+
+	pts = (pts/300)%MAX_PTS;
+	h = (uint8_t)(pts/90000)/3600;
+	m = (uint8_t)((pts/90000)%3600)/60;
+	s = (uint8_t)((pts/90000)%3600)%60;
+
+	while(c+7 < len) {
+		x=FindPacketHeader(buf, c, len);
+		if (x==-1)
+			return;
+		if (buf[x+3]==GROUP_START_CODE && (buf[x+5] & 0x08)) {
+			inserttime(buf+x, h, m, s);
+		}
+		c=x+4;
+	}
+		
+}	
+void pts2timex(uint64_t pts, uint8_t *buf, int len)
+{
+	uint8_t h,m,s;
 	int c = 0;
 
 	pts = (pts/300)%MAX_PTS;
@@ -158,17 +217,7 @@
 	while (c+7 < len){
 		if (buf[c] == 0x00 && buf[c+1] == 0x00 && buf[c+2] == 0x01 && 
 		    buf[c+3] == GROUP_START_CODE && (buf[c+5] & 0x08)){
-			buf[c+4] &= ~(0x7F);
-			buf[c+4] |= (h & 0x1F) << 2;
-			buf[c+4] |= (m & 0x30) >> 4;
-
-			buf[c+5] &= ~(0xF7);
-			buf[c+5] |= (m & 0x0F) << 4;
-			buf[c+5] |= (s & 0x38) >> 3;
-
-			buf[c+6] &= ~(0xE0);
-			buf[c+6] |= (s & 0x07) << 5;
-
+			inserttime(buf+c,h,m,s);
 /* 1hhhhhmm|mmmm1sss|sss */
 /*
 			c+=4;
@@ -186,7 +235,7 @@
 }
 
 
-int get_video_info(ringbuffer *rbuf, sequence_t *s, int off, int le)
+int get_video_info(ringbuffer *rbuf, sequence_t *s, long off, int le)
 {
         uint8_t buf[150];
         uint8_t *headr;
@@ -311,7 +360,7 @@
 	return c;
 }
 
-int find_audio_sync(ringbuffer *rbuf, uint8_t *buf, int off, int type, int le)
+int find_audio_sync(ringbuffer *rbuf, uint8_t *buf, long off, int type, int le)
 {
 	int found = 0;
 	int c=0;
@@ -364,7 +413,7 @@
 	return -1;
 }
 
-int find_audio_s(uint8_t *rbuf, int off, int type, int le)
+int find_audio_s(uint8_t *rbuf, long off, int type, int le)
 {
 	int found = 0;
 	int c=0;
@@ -411,7 +460,31 @@
 	return -1;
 }
 
-int check_audio_header(ringbuffer *rbuf, audio_frame_t * af, int  off, int le, 
+static int calculate_mpg_framesize(audio_frame_t *af)
+{
+        int frame_size;
+
+        frame_size = af->bit_rate/1000;
+        if (!frame_size) return -1;
+        switch(af->layer) {
+        case 1:
+                frame_size = (frame_size * 12000) / af->sample_rate;
+                frame_size = (frame_size + af->padding) * 4;
+                break;
+        case 2:
+                frame_size = (frame_size * 144000) / af->sample_rate;
+                frame_size += af->padding;
+                break;
+        default:
+        case 3:
+                frame_size = (frame_size * 144000) / (af->sample_rate << af->lsf);
+                frame_size += af->padding;
+                break;
+        }
+        return frame_size;
+}
+
+int check_audio_header(ringbuffer *rbuf, audio_frame_t * af, long  off, int le, 
 		       int type)
 {
 	uint8_t headr[7];
@@ -432,7 +505,7 @@
 	switch (type){
 
 	case MPEG_AUDIO:
-		if ( af->layer != ((headr[1] & 0x06) >> 1) ){
+		if ( af->layer != 4 -((headr[1] & 0x06) >> 1) ){
 			if ( headr[1] == 0xff){
 				return -3;
 			} else {
@@ -442,13 +515,26 @@
 				return -1;
 			}
 		}
-		if ( af->bit_rate != 
-		     (bitrates[(3-af->layer)][(headr[2] >> 4 )]*1000)){
+                if ( af->bit_rate !=
+                     (  af->bit_rate = bitrates[af->lsf][af->layer-1][(headr[2] >> 4 )]*1000)){
 #ifdef IN_DEBUG
-			fprintf(stderr,"Wrong audio bit rate\n");
+                        fprintf(stderr,"Wrong audio bit rate\n");
 #endif
-			return -1;
-		}
+                        return -1;
+                }
+
+                if (af->padding != ((headr[2] >> 1) & 1)){
+			int fsize;
+			af->padding = (headr[2] >> 1) & 1;
+                        if ((fsize = calculate_mpg_framesize(af)) < 0 || 
+			     abs(fsize - af->framesize) >2) return -1;
+			af->framesize = fsize;
+#ifdef IN_DEBUG
+                        fprintf(stderr,"padding changed : %d\n",af->padding);
+#endif
+
+                }
+
 		break;
 		
 	case AC3:
@@ -476,26 +562,46 @@
 }
 
 
-int get_audio_info(ringbuffer *rbuf, audio_frame_t *af, int off, int le) 
+int get_audio_info(ringbuffer *rbuf, audio_frame_t *af, long off, int le, int verb) 
 {
 	int c = 0;
 	int fr =0;
-	uint8_t headr[7];
+	uint8_t headr[4];
+        int sample_rate_index;
 
 	af->set=0;
 
 	if ( (c = find_audio_sync(rbuf, headr, off, MPEG_AUDIO,le)) < 0 ) 
 		return c;
 
-	af->layer = (headr[1] & 0x06) >> 1;
+        af->layer = 4 - ((headr[1] & 0x06) >> 1);
+//        if (af->layer >3) return -1;
 
-        if (DEBUG)
-		fprintf(stderr,"Audiostream: layer: %d", 4-af->layer);
+        if (DEBUG && verb)
+		fprintf(stderr,"Audiostream: layer: %d", af->layer);
+        if (headr[1] & (1<<4)) {
+                af->lsf = (headr[1] & (1<<3)) ? 0 : 1;
+                af->mpg25 = 0;
+		if (DEBUG && verb)
+			fprintf(stderr,"  version: 1");
+        } else {
+                af->lsf = 1;
+                af->mpg25 = 1;
+		if (DEBUG && verb)
+			fprintf(stderr,"  version: 2");
+        }
+        /* extract frequency */
+        sample_rate_index = (headr[2] >> 2) & 3;
+        if (sample_rate_index > 2) return -1;
+        af->sample_rate = freqs[sample_rate_index] >> (af->lsf + af->mpg25);
 
+	af->padding = (headr[2] >> 1) & 1;
 
-	af->bit_rate = bitrates[(3-af->layer)][(headr[2] >> 4 )]*1000;
 
-	if (DEBUG){
+        af->bit_rate = bitrates[af->lsf][af->layer-1][(headr[2] >> 4 )]*1000;
+
+
+	if (DEBUG && verb){
 		if (af->bit_rate == 0)
 			fprintf (stderr,"  Bit rate: free");
 		else if (af->bit_rate == 0xf)
@@ -505,9 +611,10 @@
 	}
 
 	fr = (headr[2] & 0x0c ) >> 2;
-	af->frequency = freq[fr]*100;
-	
-	if (DEBUG){
+	af->frequency = freqs[fr];
+
+
+	if (DEBUG && verb){
 		if (af->frequency == 3)
 			fprintf (stderr, "  Freq: reserved");
 		else
@@ -516,20 +623,16 @@
 	}
 	af->off = c;
 	af->set = 1;
-
-	af->frametime = ((samples [3-af->layer] * 27000000ULL) / af->frequency);
-	af->framesize = af->bit_rate *slots [3-af->layer]/ af->frequency;
-	fprintf(stderr," frame size: %d (", af->framesize);
-	printpts(af->frametime);
-	fprintf(stderr,") ");
-
+	af->framesize = calculate_mpg_framesize(af);
+	//af->framesize = af->bit_rate *slots [3-af->layer]/ af->frequency;
+	if (DEBUG && verb) fprintf(stderr," frame size: %d \n", af->framesize);
 	return c;
 }
 
-int get_ac3_info(ringbuffer *rbuf, audio_frame_t *af, int off, int le)
+int get_ac3_info(ringbuffer *rbuf, audio_frame_t *af, long off, int le, int verb)
 {
 	int c=0;
-	uint8_t headr[7];
+	uint8_t headr[6];
 	uint8_t frame;
 	int half = 0;
 	int fr;
@@ -544,15 +647,15 @@
 
 	af->layer = 0;  // 0 for AC3
 
-	if (DEBUG) fprintf (stderr,"AC3 stream:");
+	if (DEBUG && verb) fprintf (stderr,"AC3 stream:");
 	frame = (headr[4]&0x3F);
 	af->bit_rate = ac3_bitrates[frame>>1]*1000;
 	half = ac3half[headr[5] >> 3];
-	if (DEBUG) fprintf (stderr,"  bit rate: %d kb/s", af->bit_rate/1000);
+	if (DEBUG && verb) fprintf (stderr,"  bit rate: %d kb/s", af->bit_rate/1000);
 	fr = (headr[4] & 0xc0) >> 6;
 	af->frequency = (ac3_freq[fr] *100) >> half;
 	
-	if (DEBUG) fprintf (stderr,"  freq: %d Hz\n", af->frequency);
+	if (DEBUG && verb) fprintf (stderr,"  freq: %d Hz\n", af->frequency);
 
 	switch (headr[4] & 0xc0) {
 	case 0:
@@ -568,19 +671,15 @@
 		break;
 	}
 
-	if (DEBUG) fprintf (stderr,"  frame size %d\n", af->framesize);
+	if (DEBUG && verb) fprintf (stderr,"  frame size %d\n", af->framesize);
 
 	af->off = c;
 	af->set = 1;
-
-	//FIXME calculate frametime
-	af->frametime = 0;
-
-    return c;
+	return c;
 }
 
 
-int get_video_ext_info(ringbuffer *rbuf, sequence_t *s, int off, int le)
+int get_video_ext_info(ringbuffer *rbuf, sequence_t *s, long off, int le)
 {
         uint8_t *headr;
         uint8_t buf[12];
@@ -612,8 +711,10 @@
 
 		if (DEBUG) fprintf(stderr,"Sequence Extension:");
 		s->profile = ((headr[0]&0x0F) << 4) | ((headr[1]&0xF0) >> 4);
-		if (headr[1]&0x08) s->progressive = 1;
-		else s->progressive = 0;
+		if (headr[1]&0x08){
+			s->progressive = 1;
+			if (DEBUG) fprintf(stderr," progressive sequence ");
+		} else s->progressive = 0;
 		s->chroma = (headr[1]&0x06)>>1;
 		if (DEBUG){
 			switch(s->chroma){
@@ -660,30 +761,41 @@
 		break;
 
 	case PICTURE_CODING_EXTENSION:{
-		int pulldown = 0;
+		int repeat_first = 0;
+		int top_field = 0;
+		int prog_frame = 0;
 
 		if (!s->set || s->pulldown_set) break;
 		if (ring_peek(rbuf, buf, 10, off) < 0) return -2;
 		headr=buf+4;
 		
 		if ( (headr[2]&0x03) != 0x03 ) break; // not frame picture
-		if ( (headr[3]&0x02) ) pulldown = 1; // repeat flag set => pulldown
+		if ( (headr[3]&0x02) ) repeat_first = 1; // repeat flag set => pulldown
+		if ( (headr[3]&0x80) ) top_field=1; 
+		if ( (headr[4]&0x80) ) prog_frame=1; 
+ 
+		if (repeat_first) {
+			if (!s->progressive){
+				if (s->current_tmpref)
+					s->pulldown = PULLDOWN23;
+				else
+					s->pulldown = PULLDOWN32;
+				s->pulldown_set = 1;
+			} else {
+				if(prog_frame && top_field)
+					s->progressive = TWO_FIELD;
+//				if (DEBUG) fprintf(stderr,"Picture Coding Extension: progressive tmp %d top %d prog %d rep %d\n", s->current_tmpref, top_field, prog_frame, repeat_first);
+			}
+		}
 
-		if (pulldown){
-			if (s->current_tmpref)
-				s->pulldown = PULLDOWN23;
-			else
-				s->pulldown = PULLDOWN32;
-			s->pulldown_set = 1;
-		} 
 		if (DEBUG){
 			switch (s->pulldown) {
 			case PULLDOWN32:
-				if (DEBUG) fprintf(stderr,"Picture Coding Extension:");
+				fprintf(stderr,"Picture Coding Extension:");
 				fprintf(stderr," 3:2 pulldown detected \n");
 				break;
 			case PULLDOWN23:
-				if (DEBUG) fprintf(stderr,"Picture Coding Extension:");
+				fprintf(stderr,"Picture Coding Extension:");
 				fprintf(stderr," 2:3 pulldown detected \n");
 				break;
 //			default:
Index: replex/ringbuffer.c
===================================================================
--- replex/ringbuffer.c	(revision 18755)
+++ replex/ringbuffer.c	(working copy)
@@ -2,8 +2,10 @@
  * ringbuffer.c
  *        
  *
- * Copyright (C) 2003 Marcus Metzler <mocm@metzlerbros.de>
+ * Copyright (C) 2003 - 2006
+ *                    Marcus Metzler <mocm@metzlerbros.de>
  *                    Metzler Brothers Systementwicklung GbR
+ *           (C) 2006 Reel Multimedia
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
@@ -30,6 +32,7 @@
 #include "pes.h"
 
 #define DEBUG 1
+// Initialize buffer
 int ring_init (ringbuffer *rbuf, int size)
 {
 	if (size > 0){
@@ -47,26 +50,7 @@
 	return 0;
 }
 
-int ring_reinit (ringbuffer *rbuf, int size)
-{
-	if (size > (int)(rbuf->size)) {
-		uint8_t *tmpalloc = (uint8_t *) realloc(rbuf->buffer,
-							sizeof(uint8_t)*size);
-		if (! tmpalloc)
-			return -1;
-		rbuf->buffer = tmpalloc;
-		if (rbuf->write_pos < rbuf->read_pos)
-		{
-			unsigned int delta = size - rbuf->size;
-			memmove(rbuf->buffer + rbuf->read_pos + delta,
-				rbuf->buffer + rbuf->read_pos,
-				rbuf->size - rbuf->read_pos);
-			rbuf->read_pos += delta;
-		}
-		rbuf->size = size;
-	}
-	return 0;
-}
+// reset buffer
 void ring_clear(ringbuffer *rbuf)
 {
 	rbuf->read_pos = 0;	
@@ -74,13 +58,14 @@
 }
 
 
-
+// delete buffer
 void ring_destroy(ringbuffer *rbuf)
 {
 	free(rbuf->buffer);
 }
 
 
+//write into buffer
 int ring_write(ringbuffer *rbuf, uint8_t *data, int count)
 {
 
@@ -92,9 +77,13 @@
 	free = ring_free(rbuf);
 
 	if ( free < count ){
-		if (DEBUG) fprintf(stderr,"ringbuffer overflow %d<%d %d\n", 
-				   free, count, rbuf->size);
-		return FULL_BUFFER;
+		if ( free > 0 ){
+			count = free;
+		} else {
+			if (DEBUG) fprintf(stderr,"ringbuffer overflow %d<%d %d\n", 
+					   free, count, rbuf->size);
+			return FULL_BUFFER;
+		}
 	}
 	
 	if (count >= rest){
@@ -112,10 +101,11 @@
 	return count;
 }
 
-int ring_peek(ringbuffer *rbuf, uint8_t *data, unsigned int count, uint32_t off)
+// peek into buffer
+int ring_peek(ringbuffer *rbuf, uint8_t *data, int count, long off)
 {
 
-	unsigned int avail, pos, rest;
+	int avail, pos, rest;
 
 	if (count <=0 || off+count > rbuf->size || off+count >ring_avail(rbuf)) return -1;
 	pos  = (rbuf->read_pos+off)%rbuf->size;
@@ -140,34 +130,8 @@
 	return count;
 }
 
-int ring_poke(ringbuffer *rbuf, uint8_t *data, unsigned int count, uint32_t off)
-{
 
-	unsigned int avail, pos, rest;
-
-	if (count <=0 || off+count > rbuf->size || off+count >ring_avail(rbuf)) return -1;
-	pos  = (rbuf->read_pos+off)%rbuf->size;
-	rest = rbuf->size - pos ;
-	avail = ring_avail(rbuf); 
-
-	
-	if ( avail < count ){
-//		if (DEBUG) fprintf(stderr,"ringbuffer peek underflow %d<%d %d %d\n", 
-//				   avail, count, pos, rbuf->write_pos);
-		return EMPTY_BUFFER;
-	}
-
-	if ( count < rest ){
-		memcpy(rbuf->buffer+pos, data, count);
-	} else {
-		memcpy(rbuf->buffer+pos, data, rest);
-		if ( count - rest)
-			memcpy(rbuf->buffer, data+rest, count - rest);
-	}
-
-	return count;
-}
-
+//read from buffer
 int ring_read(ringbuffer *rbuf, uint8_t *data, int count)
 {
 
@@ -199,6 +163,7 @@
 	return count;
 }
 
+//skip buffer
 int ring_skip(ringbuffer *rbuf, int count)
 {
 
@@ -226,7 +191,7 @@
 }
 
 
-
+// write from file into buffer
 int ring_write_file(ringbuffer *rbuf, int fd, int count)
 {
 
@@ -237,11 +202,13 @@
 	rest = rbuf->size - pos;
 	free = ring_free(rbuf);
 
-	if ( free < count ){
+	if ( !free ){
 		if (DEBUG) fprintf(stderr,"ringbuffer overflow %d<%d %d %d\n", 
 				   free, count, pos, rbuf->read_pos);
 		return FULL_BUFFER;
 	}
+
+	if ( count > free ) count = free;
 	
 	if (count >= rest){
 		rr = read (fd, rbuf->buffer+pos, rest);
@@ -262,6 +229,7 @@
 
 
 
+// write from buffer into file
 int ring_read_file(ringbuffer *rbuf, int fd, int count)
 {
 
@@ -296,7 +264,7 @@
 	return rr;
 }
 
-
+// print memory 
 static void show(uint8_t *buf, int length)
 {
 	int i,j,r;
@@ -329,10 +297,10 @@
 	}
 }
 
-void ring_show(ringbuffer *rbuf, unsigned int count, uint32_t off)
+void ring_show(ringbuffer *rbuf, int count, long off)
 {
 
-	unsigned int avail, pos, rest;
+	int avail, pos, rest;
 
 	if (count <=0 || off+count > rbuf->size || off+count >ring_avail(rbuf)) return;
 	pos  = (rbuf->read_pos+off)%rbuf->size;
@@ -368,12 +336,6 @@
 	return 0;
 }
 
-void dummy_destroy(dummy_buffer *dbuf)
-{
-        ring_destroy(&dbuf->time_index);
-        ring_destroy(&dbuf->data_index);
-}
-
 void dummy_clear(dummy_buffer *dbuf)
 {
 	dbuf->fill = 0;
@@ -423,6 +385,7 @@
 
 	return dsize;
 }
+/*
 void dummy_print(dummy_buffer *dbuf)
 {
    int i;
@@ -439,3 +402,4 @@
    }
    printf("Used: %d Free: %d data-free: %d\n", avail, 1000-avail, dbuf->size - dbuf->fill);
 }
+*/
Index: replex/mpg_common.c
===================================================================
--- replex/mpg_common.c	(revision 18755)
+++ replex/mpg_common.c	(working copy)
@@ -2,8 +2,10 @@
  * mpg_common.c: COMMON MPEG functions for replex
  *        
  *
- * Copyright (C) 2003 Marcus Metzler <mocm@metzlerbros.de>
+ * Copyright (C) 2003 - 2006
+ *                    Marcus Metzler <mocm@metzlerbros.de>
  *                    Metzler Brothers Systementwicklung GbR
+ *           (C) 2006 Reel Multimedia
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
@@ -61,11 +63,93 @@
 	}
 }
 
+//----------------------------------------------------------------------------
+#define CMP_CORE(offset) \
+        x=Data[i+1+offset]; \
+        if (x<2) { \
+                if (x==0) { \
+                        if ( Data[i+offset]==0 && Data[i+2+offset]==1) \
+                                return i+offset; \
+                        else if (Data[i+2+offset]==0 && Data[i+3+offset]==1) \
+                                return i+1+offset; \
+                } \
+                else if (x==1 && Data[i-1+offset]==0 && Data[i+offset]==0 && (i+offset)>0) \
+                         return i-1+offset; \
+         }
 
+int FindPacketHeader(const uint8_t *Data, int s, int l)
+{
+        int i;
+        uint8_t x;
 
-int find_mpg_header(uint8_t head, uint8_t *buf, int length)
+        if (l>12) {
+                for(i=s;i<l-12;i+=12) { 
+                        CMP_CORE(0);
+                        CMP_CORE(3);
+                        CMP_CORE(6);
+                        CMP_CORE(9);
+                }
+
+                for(; i<l-3; i+=3) {
+                        CMP_CORE(0);
+		}	       
+        }
+        else {
+                for(i=s; i<l-3; i+=3) {
+                        CMP_CORE(0);
+		}
+        }
+        return -1;
+}
+//----------------------------------------------------------------------------
+
+int find_mpg_header(uint8_t head, uint8_t *buf, int Count)
 {
+	int n=0;
+	uint8_t *Data=buf;
+        while(n<Count) {
+                int x;
+                x=FindPacketHeader(Data, 0, Count - n); // returns position of first 00
+                if (x!=-1) {
+                        Data+=x;
+                        n+=x;
+			if (Data[3]==head) {
+                                return n; 
+                        }
+                        n+=3;
+                        Data+=3;
+                        Count-=3;
+                }
+                else
+                        break;
+        }
+        return -1;
 
+}
+
+int find_any_header(uint8_t *head, uint8_t *buf, int Count)
+{
+	int n=0;
+	uint8_t *Data=buf;
+        while(n<Count) {
+                int x;
+                x=FindPacketHeader(Data, 0, Count - n); // returns position of first 00
+                if (x!=-1) {
+                        Data+=x;
+                        n+=x;
+			*head=Data[3];
+			return n; 
+                }
+                else
+                        break;
+        }
+        return -1;
+
+}
+
+int find_mpg_headerx(uint8_t head, uint8_t *buf, int length)
+{
+
 	int c = 0;
 	int found=0;
 
@@ -99,7 +183,7 @@
 }
 
 
-int find_any_header(uint8_t *head, uint8_t *buf, int length)
+int find_any_headerx(uint8_t *head, uint8_t *buf, int length)
 {
 
 	int c = 0;
@@ -153,7 +237,7 @@
 }
 
 
-int mring_peek( ringbuffer *rbuf, uint8_t *buf, unsigned int l, uint32_t off)
+int mring_peek( ringbuffer *rbuf, uint8_t *buf, int l, long off)
 {
         int c = 0;
 
@@ -205,9 +289,59 @@
 }
 
 
-int ring_find_any_header(ringbuffer *rbuf, uint8_t *head, int off, int le)
+#define PEEK_SIZE (512+1024)
+int ring_find_any_headery(ringbuffer *rbuf, uint8_t *head, int off, int le)
 {
+	uint8_t buf[PEEK_SIZE];
+//	int xoff;
+	int res,x;
+//	int found;
+	int n=off;
+	int peek_snip;
+//	printf("# %i %i\n",off,le);
+	while(le>0) {
+		if (le>PEEK_SIZE)
+			peek_snip=PEEK_SIZE;
+		else
+			peek_snip=le;
 
+		res=mring_peek(rbuf, buf, peek_snip, n);
+		if (res<0) {
+			peek_snip=ring_avail(rbuf);
+//			printf("PP %i\n",peek_snip);
+			if (peek_snip>PEEK_SIZE)
+				peek_snip=PEEK_SIZE;
+			if (peek_snip>le)
+				peek_snip=le;
+			res=mring_peek(rbuf,buf,peek_snip,n);
+			if (res<0)
+				return -1;
+		}
+//		printf("ZZ %i %i\n",peek_snip,n);
+		x=FindPacketHeader(buf, 0, peek_snip); // returns position of first 00
+                if (x!=-1 && x<=peek_snip-4) {
+                        n+=x-off;
+			
+			*head=buf[x+3];
+			return n; 
+                }
+		if (peek_snip<=4) {
+			int i;
+			for(i=0;i<peek_snip;i++)
+				if (buf[i]==0)
+					return -2;
+			return -1;
+		}
+
+		n+=peek_snip-4;
+		le-=peek_snip-4;
+	}
+	return -1; // Not found
+}
+
+int ring_find_any_headerx(ringbuffer *rbuf, uint8_t *head, int off, int le)
+{
+
 	int c = 0;
 	int found =0;
 
@@ -244,3 +378,19 @@
 	else return -1;
 }
 
+int ring_find_any_header(ringbuffer *rbuf, uint8_t *head, int off, int le)
+{
+	uint8_t a=0;
+//	uint8_t b=0;
+	int x;
+//	int y;
+
+	x=ring_find_any_headery(rbuf, &a, off, le);
+#if 0
+	y=ring_find_any_headery(rbuf, &b, off, le);
+	if (x!=y || a!=b)
+		printf("MY %i %i, ORG %i %i\n",y, b, x, a);
+#endif
+	*head=a;
+	return x;
+}
Index: replex/ts.h
===================================================================
--- replex/ts.h	(revision 18755)
+++ replex/ts.h	(working copy)
@@ -2,7 +2,8 @@
  * ts.h
  *        
  *
- * Copyright (C) 2003 Marcus Metzler <mocm@metzlerbros.de>
+ * Copyright (C) 2003 - 2006
+ *                    Marcus Metzler <mocm@metzlerbros.de>
  *                    Metzler Brothers Systementwicklung GbR
  *
  * This program is free software; you can redistribute it and/or
@@ -27,9 +28,6 @@
 #ifndef _TS_H_
 #define _TS_H_
 
-#include "ringbuffer.h"
-#include "mpg_common.h"
-
 #define TS_SIZE        188
 #define TRANS_ERROR    0x80
 #define PAY_START      0x40
@@ -58,19 +56,7 @@
 #define PIECE_RATE     0x40
 #define SEAM_SPLICE    0x20
 
-#define TS_VIDPID      4101
-#define TS_MP2PID      4201
-#define TS_AC3PID      4301
 uint16_t get_pid(uint8_t *pid);
 int find_pids(uint16_t *vpid, uint16_t *apid, uint16_t *ac3pid,uint8_t *buf, int len);
 int find_pids_pos(uint16_t *vpid, uint16_t *apid, uint16_t *ac3pid,uint8_t *buf, int len, int *vpos, int *apos, int *ac3pos);
-
-int write_video_ts(uint64_t vpts, uint64_t vdts, uint64_t SCR,
-	     uint8_t *buf, int *vlength, uint8_t ptsdts, ringbuffer *vrbuffer);
-int write_audio_ts(int n, uint64_t pts, 
-	     uint8_t *buf, int *alength, uint8_t ptsdts, ringbuffer *arbuffer);
-int write_ac3_ts(int n, uint64_t pts, uint8_t *buf, int *alength,
-	 uint8_t ptsdts, int nframes, ringbuffer *ac3rbuffer);
-void write_ts_patpmt(extdata_t *ext, int extcnt, uint8_t prog_num,
-			uint8_t *buf);
 #endif /*_TS_H_*/
Index: replex/pes.h
===================================================================
--- replex/pes.h	(revision 18755)
+++ replex/pes.h	(working copy)
@@ -1,7 +1,31 @@
-/* 
-    Copyright (C) 2003 Marcus Metzler (mocm@metzlerbros.de)
+/*
+ * pes.h: MPEG PES functions for replex
+ *        
+ *
+ * Copyright (C) 2003 - 2006
+ *                    Marcus Metzler <mocm@metzlerbros.de>
+ *                    Metzler Brothers Systementwicklung GbR
+ *           (C) 2006 Reel Multimedia
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+ *
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * General Public License for more details.
+ *
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ * Or, point your browser to http://www.gnu.org/copyleft/gpl.html
+ *
+ */
 
-*/
 
 #ifndef _PES_H_
 #define _PES_H_
@@ -9,7 +33,6 @@
 #include <stdint.h>
 #include "ringbuffer.h"
 
-#define TS_HEADER_MIN	4
 #define PS_HEADER_L1    14
 #define PS_HEADER_L2    (PS_HEADER_L1+24)
 #define PES_MIN         7
@@ -71,7 +94,7 @@
 typedef
 struct pes_in_s{
 	int type;
-	unsigned int found;
+	int found;
 	int withbuf;
 	uint8_t *buf;
 	ringbuffer *rbuf;
@@ -102,25 +125,29 @@
 uint64_t ptsadd(uint64_t pts1, uint64_t pts2);
 
 
-int write_pes_header(uint8_t id, int length , uint64_t PTS, uint64_t DTS, 
-		     uint8_t *obuf, int stuffing, uint8_t ptsdts);
-void write_padding_pes( int pack_size, int extcnt, 
+void write_padding_pes( int pack_size, int apidn, int ac3n, 
 			uint64_t SCR, uint64_t muxr, uint8_t *buf);
-int write_ac3_pes(  int pack_size, int extcnt, int n, uint64_t pts, 
+int write_ac3_pes(  int pack_size, int apidn, int ac3n, int n, uint64_t pts, 
 		    uint64_t SCR, 
 		    uint32_t muxr, uint8_t *buf, int *alength, uint8_t ptsdts,
-		    int nframes,int ac3_off, ringbuffer *ac3rbuffer);
-int write_audio_pes(  int pack_size, int extcnt, int n, uint64_t pts, 
+		    int nframes,int ac3_off, ringbuffer *ac3rbuffer, int framelength);
+int bwrite_ac3_pes(  int pack_size, int apidn, int ac3n, int n, uint64_t pts, 
+		    uint64_t SCR, 
+		    uint32_t muxr, uint8_t *buf, int *alength, uint8_t ptsdts,
+		     int nframes,int ac3_off, uint8_t *ac3rbuffer, int bsize, int framelength);
+int write_audio_pes(  int pack_size, int apidn, int ac3n, int n, uint64_t pts, 
 		      uint64_t SCR, uint32_t muxr, uint8_t *buf, int *alength, 
 		      uint8_t ptsdts, 	ringbuffer *arbuffer);
-int write_video_pes( int pack_size, int extcnt, uint64_t vpts, 
+int bwrite_audio_pes(  int pack_size, int apidn, int ac3n, int n, uint64_t pts, 
+		      uint64_t SCR, uint32_t muxr, uint8_t *buf, int *alength, 
+		       uint8_t ptsdts, uint8_t *arbuffer, int bsize );
+int write_video_pes( int pack_size, int apidn, int ac3n, uint64_t vpts, 
 		     uint64_t vdts, uint64_t SCR, uint64_t muxr, 
 		     uint8_t *buf, int *vlength, 
 		     uint8_t ptsdts, ringbuffer *vrbuffer);
-int write_nav_pack(int pack_size, int extcnt, uint64_t SCR, uint32_t muxr, 
+int write_nav_pack(int pack_size, int apidn, int ac3n, uint64_t SCR, uint32_t muxr, 
 		   uint8_t *buf);
 
-
 static inline void ptsdec(uint64_t *pts1, uint64_t pts2)
 {
 	*pts1= uptsdiff(*pts1, pts2);
